package net.knarcraft.bookswithoutborders.listener;

import net.knarcraft.bookswithoutborders.config.BooksWithoutBordersConfig;
import net.knarcraft.bookswithoutborders.utility.BookFormatter;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.PlayerEditBookEvent;

/**
 * A listener for listening to book events
 *
 * <p>Mainly used for auto-formatting signed books if enabled</p>
 */
public class BookEventListener implements Listener {

    @EventHandler
    public void onBookSign(PlayerEditBookEvent event) {
        if (event.isCancelled() || !event.isSigning() || !BooksWithoutBordersConfig.formatBooks()) {
            return;
        }
        event.setNewBookMeta(BookFormatter.formatPages(event.getNewBookMeta()));
    }

}
