package net.knarcraft.bookswithoutborders.state;

/**
 * This enum represents the different directories books can be saved in
 */
public enum BookDirectory {

    /**
     * The public directory
     */
    PUBLIC,

    /**
     * A player directory
     */
    PLAYER,

    /**
     * The encrypted directory
     */
    ENCRYPTED;

    /**
     * Gets the relevant book directory given a directory name
     *
     * @param directory <p>The directory to transform</p>
     * @return <p>A book directory, or null if the given directory is empty</p>
     */
    public static BookDirectory getFromString(String directory) {
        if (directory.equalsIgnoreCase("public")) {
            return BookDirectory.PUBLIC;
        } else if (directory.equalsIgnoreCase("player")) {
            return BookDirectory.PLAYER;
        } else if (!directory.trim().isEmpty()) {
            return BookDirectory.ENCRYPTED;
        } else {
            return null;
        }
    }

}
