package net.knarcraft.bookswithoutborders.state;

/**
 * This enum represents the different available encryption styles
 */
public enum EncryptionStyle {

    DNA("dna"),
    SUBSTITUTION("substitution");

    private final String name;

    EncryptionStyle(String name) {
        this.name = name;
    }

    /**
     * Gets an encryption style given its name
     *
     * @param name <p>The name of the encryption style</p>
     * @return <p>An encryption style or null if no match is found</p>
     */
    public static EncryptionStyle getFromString(String name) {
        for (EncryptionStyle style : EncryptionStyle.values()) {
            if (style.name.equalsIgnoreCase(name)) {
                return style;
            }
        }
        return SUBSTITUTION;
    }

}
